## opendungeons 0.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,12 +13,10 @@
     set(PROJECT_BINARY_NAME "opendungeons")
 endif()
 
-set(AS_LIBRARY_NAME "angelscript")
-
 # Project version
 set(OD_MAJOR_VERSION 0)
-set(OD_MINOR_VERSION 6)
-set(OD_PATCH_LEVEL   0)
+set(OD_MINOR_VERSION 7)
+set(OD_PATCH_LEVEL   1)
 
 # Set the project version ready to be used in the code.
 if(NOT MSVC)
@@ -29,6 +27,7 @@
 if(WIN32)
     set(OD_DATA_PATH ".")
     set(OD_PLUGINS_CFG_PATH ".")
+    set(OD_BIN_PATH ${CMAKE_INSTALL_PREFIX})
 else()
     # Set binary and data install locations if we want to use the installer
     set(OD_BIN_PATH ${CMAKE_INSTALL_PREFIX}/games CACHE PATH "Absolute path to the game binary directory")
@@ -65,10 +64,6 @@
 
 #project paths
 set(SRC "${CMAKE_SOURCE_DIR}/source")
-#set(DEPENDENCIES_DIR "${CMAKE_SOURCE_DIR}/dependencies")
-#set(ANGELSCRIPT_DIR "${DEPENDENCIES_DIR}/angelscript")
-#set(ANGELSCRIPT_SRC_DIR "${ANGELSCRIPT_DIR}/angelscript/source")
-#set(ANGELSCRIPT_ADDON_DIR "${ANGELSCRIPT_DIR}/add_on")
 
 #cmake paths
 set(CMAKE_CONFIG_DIR "${CMAKE_SOURCE_DIR}/cmake/config")
@@ -88,6 +83,43 @@
     add_definitions("-DOD_DEBUG")
 endif()
 
+# From Boost cmake file
+
+# We want to differentiate MinGW64 and MinGW32
+if(WIN32 AND MINGW)
+    exec_program(${CMAKE_CXX_COMPILER} ARGS ${CMAKE_CXX_COMPILER_ARG1} -dumpversion OUTPUT_VARIABLE OD_MINGW_COMPILER_VERSION)
+    string(REGEX REPLACE "([0-9])\\.([0-9])(\\.[0-9])?" "\\1\\2" OD_MINGW_COMPILER_VERSION ${OD_MINGW_COMPILER_VERSION})
+    message(STATUS "OD_MINGW_COMPILER_VERSION: ${OD_MINGW_COMPILER_VERSION}")
+endif()
+
+## We check for dependencies
+set(OD_DEPENDENCIES_DIR "$ENV{OD_DEPS}" CACHE PATH "Path to prebuilt OD dependencies")
+if(OD_DEPENDENCIES_DIR)
+    if(WIN32 AND MINGW)
+        set(OD_ARCH_SUFIX "/mingw${OD_MINGW_COMPILER_VERSION}")
+    elseif(WIN32 AND MSVC)
+        set(OD_ARCH_SUFIX "/msvc")
+    else()
+        set(OD_ARCH_SUFIX "")
+    endif()
+    set(OD_DEP_SEARCH_PATH
+    # Boost binaries contains compiler name. They can be put in the same directory
+        ${OD_DEPENDENCIES_DIR}/boost
+        ${OD_DEPENDENCIES_DIR}/stage/lib
+        ${OD_DEPENDENCIES_DIR}/cegui/include/cegui-0
+        ${OD_DEPENDENCIES_DIR}/cegui/lib${OD_ARCH_SUFIX}
+        ${OD_DEPENDENCIES_DIR}/ogresdk/include
+        ${OD_DEPENDENCIES_DIR}/ogresdk/lib${OD_ARCH_SUFIX}
+        ${OD_DEPENDENCIES_DIR}/sfml/include
+        ${OD_DEPENDENCIES_DIR}/sfml/lib${OD_ARCH_SUFIX}
+        )
+
+    # hints to the find_package calls
+    set(CMAKE_PREFIX_PATH ${OD_DEP_SEARCH_PATH} ${CMAKE_PREFIX_PATH})
+
+    message(STATUS "Search path dependencies: ${OD_DEP_SEARCH_PATH}")
+endif()
+
 ##################################
 #### ExplicitCompilerFlags #######
 ##################################
@@ -107,10 +139,11 @@
     include(CheckCXXCompilerFlag)
     if(NOT OD_CXX11_FLAGS)
         CHECK_CXX_COMPILER_FLAG("-std=c++11" OD_CXX11_FLAG_SUPPORTED)
+        CHECK_CXX_COMPILER_FLAG("-std=gnu++11" OD_CXXGNU11_FLAG_SUPPORTED)
         # MinGW supports CXX11 flag but do not compile with it. However, it works with gnu++11
         if(OD_CXX11_FLAG_SUPPORTED AND NOT MINGW)
             set(OD_CXX11_FLAGS "-std=c++11" CACHE STRING "Compilation flags to enable C++11 support" FORCE)
-        else()
+        elseif(OD_CXX11_FLAG_SUPPORTED)
             set(OD_CXX11_FLAGS "-std=gnu++11" CACHE STRING "Compilation flags to enable C++11 support" FORCE)
         endif()
     endif()
@@ -173,132 +206,80 @@
 ##################################
 
 #Add new .cpp files here so that they get compiled
-#set(AS_SOURCEFILES
-    #AngelScript sources
-#    ${ANGELSCRIPT_SRC_DIR}/as_atomic.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_builder.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_bytecode.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc.cpp
-#Disabling exotic platforms for now
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc_arm.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc_mips.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc_ppc.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc_ppc_64.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc_sh4.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc_x64_gcc.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc_x64_msvc.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc_x64_mingw.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc_x86.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_callfunc_xenon.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_compiler.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_configgroup.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_context.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_datatype.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_gc.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_generic.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_globalproperty.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_memory.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_module.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_objecttype.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_outputbuffer.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_parser.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_restore.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_scriptcode.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_scriptengine.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_scriptfunction.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_scriptnode.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_scriptobject.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_string.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_string_util.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_thread.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_tokenizer.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_typeinfo.cpp
-#    ${ANGELSCRIPT_SRC_DIR}/as_variablescope.cpp
-
-    #AngelScript Addon sources
-#    ${ANGELSCRIPT_ADDON_DIR}/scriptarray/scriptarray.cpp
-#    ${ANGELSCRIPT_ADDON_DIR}/scriptbuilder/scriptbuilder.cpp
-#    ${ANGELSCRIPT_ADDON_DIR}/scripthelper/scripthelper.cpp
-#    ${ANGELSCRIPT_ADDON_DIR}/scriptstdstring/scriptstdstring.cpp
-#)
 set(OD_SOURCEFILES
 
     #OpenDungeons sources
+    ${SRC}/ai/AIFactory.cpp
     ${SRC}/ai/AIManager.cpp
     ${SRC}/ai/BaseAI.cpp
     ${SRC}/ai/KeeperAI.cpp
+    ${SRC}/ai/KeeperAIType.cpp
 
     ${SRC}/camera/CameraManager.cpp
     ${SRC}/camera/HermiteCatmullSpline.cpp
+    ${SRC}/camera/CullingManager.cpp
+    ${SRC}/camera/CullingVectorManager.cpp
+    ${SRC}/camera/SlopeWalk.cpp
+
+    ${SRC}/creatureaction/CreatureAction.cpp
+    ${SRC}/creatureaction/CreatureActionCarryEntity.cpp
+    ${SRC}/creatureaction/CreatureActionClaimGroundTile.cpp
+    ${SRC}/creatureaction/CreatureActionClaimWallTile.cpp
+    ${SRC}/creatureaction/CreatureActionDigTile.cpp
+    ${SRC}/creatureaction/CreatureActionEatChicken.cpp
+    ${SRC}/creatureaction/CreatureActionFight.cpp
+    ${SRC}/creatureaction/CreatureActionFightFriendly.cpp
+    ${SRC}/creatureaction/CreatureActionFindHome.cpp
+    ${SRC}/creatureaction/CreatureActionFlee.cpp
+    ${SRC}/creatureaction/CreatureActionGetFee.cpp
+    ${SRC}/creatureaction/CreatureActionGrabEntity.cpp
+    ${SRC}/creatureaction/CreatureActionLeaveDungeon.cpp
+    ${SRC}/creatureaction/CreatureActionSearchEntityToCarry.cpp
+    ${SRC}/creatureaction/CreatureActionSearchFood.cpp
+    ${SRC}/creatureaction/CreatureActionSearchGroundTileToClaim.cpp
+    ${SRC}/creatureaction/CreatureActionSearchJob.cpp
+    ${SRC}/creatureaction/CreatureActionSearchTileToDig.cpp
+    ${SRC}/creatureaction/CreatureActionSearchWallTileToClaim.cpp
+    ${SRC}/creatureaction/CreatureActionSleep.cpp
+    ${SRC}/creatureaction/CreatureActionStealFreeGold.cpp
+    ${SRC}/creatureaction/CreatureActionUseRoom.cpp
+    ${SRC}/creatureaction/CreatureActionWalkToTile.cpp
+
+    ${SRC}/creaturebehaviour/CreatureBehaviour.cpp
+    ${SRC}/creaturebehaviour/CreatureBehaviourAttackEnemy.cpp
+    ${SRC}/creaturebehaviour/CreatureBehaviourEngageNaturalEnemy.cpp
+    ${SRC}/creaturebehaviour/CreatureBehaviourFleeWhenWeak.cpp
+    ${SRC}/creaturebehaviour/CreatureBehaviourLeaveDungeonWhenFurious.cpp
+    ${SRC}/creaturebehaviour/CreatureBehaviourManager.cpp
 
     ${SRC}/creatureeffect/CreatureEffect.cpp
+    ${SRC}/creatureeffect/CreatureEffectDefense.cpp
     ${SRC}/creatureeffect/CreatureEffectExplosion.cpp
     ${SRC}/creatureeffect/CreatureEffectHeal.cpp
+    ${SRC}/creatureeffect/CreatureEffectManager.cpp
     ${SRC}/creatureeffect/CreatureEffectSlap.cpp
     ${SRC}/creatureeffect/CreatureEffectSpeedChange.cpp
+    ${SRC}/creatureeffect/CreatureEffectStrengthChange.cpp
 
     ${SRC}/creaturemood/CreatureMood.cpp
-    ${SRC}/creaturemood/CreatureMoodAwakness.cpp
+    ${SRC}/creaturemood/CreatureMoodWakefulness.cpp
     ${SRC}/creaturemood/CreatureMoodCreature.cpp
     ${SRC}/creaturemood/CreatureMoodFee.cpp
     ${SRC}/creaturemood/CreatureMoodHunger.cpp
     ${SRC}/creaturemood/CreatureMoodHpLoss.cpp
+    ${SRC}/creaturemood/CreatureMoodManager.cpp
     ${SRC}/creaturemood/CreatureMoodTurnsWithoutFight.cpp
 
+    ${SRC}/creatureskill/CreatureSkill.cpp
+    ${SRC}/creatureskill/CreatureSkillDefenseSelf.cpp
+    ${SRC}/creatureskill/CreatureSkillExplosion.cpp
+    ${SRC}/creatureskill/CreatureSkillHasteSelf.cpp
+    ${SRC}/creatureskill/CreatureSkillHealSelf.cpp
+    ${SRC}/creatureskill/CreatureSkillManager.cpp
+    ${SRC}/creatureskill/CreatureSkillMeleeFight.cpp
+    ${SRC}/creatureskill/CreatureSkillMissileLaunch.cpp
+    ${SRC}/creatureskill/CreatureSkillSlow.cpp
+    ${SRC}/creatureskill/CreatureSkillStrengthSelf.cpp
+    ${SRC}/creatureskill/CreatureSkillWeak.cpp
+
     ${SRC}/entities/Building.cpp
-    ${SRC}/entities/BuildingObject.cpp
-    ${SRC}/entities/ChickenEntity.cpp
-    ${SRC}/entities/CraftedTrap.cpp
-    ${SRC}/entities/Creature.cpp
-    ${SRC}/entities/CreatureAction.cpp
-    ${SRC}/entities/CreatureDefinition.cpp
-    ${SRC}/entities/DoorEntity.cpp
-    ${SRC}/entities/EntityBase.cpp
-    ${SRC}/entities/EntityLoading.cpp
-    ${SRC}/entities/GameEntity.cpp
-    ${SRC}/entities/GameEntityType.cpp
-    ${SRC}/entities/GiftBoxEntity.cpp
-    ${SRC}/entities/MapLight.cpp
-    ${SRC}/entities/MissileBoulder.cpp
-    ${SRC}/entities/MissileObject.cpp
-    ${SRC}/entities/MissileOneHit.cpp
-    ${SRC}/entities/MovableGameEntity.cpp
-    ${SRC}/entities/PersistentObject.cpp
-    ${SRC}/entities/RenderedMovableEntity.cpp
-    ${SRC}/entities/ResearchEntity.cpp
-    ${SRC}/entities/SmallSpiderEntity.cpp
-    ${SRC}/entities/Tile.cpp
-    ${SRC}/entities/TileFunctions.cpp
-    ${SRC}/entities/TrapEntity.cpp
-    ${SRC}/entities/TreasuryObject.cpp
-    ${SRC}/entities/Weapon.cpp
-
-    ${SRC}/game/Player.cpp
-    ${SRC}/game/PlayerFunctions.cpp
-    ${SRC}/game/PlayerSelection.cpp
-    ${SRC}/game/Research.cpp
-    ${SRC}/game/ResearchManager.cpp
-    ${SRC}/game/Seat.cpp
-    ${SRC}/game/SeatFunctions.cpp
-
-    ${SRC}/gamemap/GameMap.cpp
-    ${SRC}/gamemap/MapLoader.cpp
-    ${SRC}/gamemap/MiniMap.cpp
-    ${SRC}/gamemap/MiniMapCamera.cpp
-    ${SRC}/gamemap/TileContainer.cpp
-    ${SRC}/gamemap/TileSet.cpp
-
-    ${SRC}/giftboxes/GiftBoxResearch.cpp
-
-    ${SRC}/goals/Goal.cpp
-    ${SRC}/goals/GoalClaimNTiles.cpp
-    ${SRC}/goals/GoalLoading.cpp
-    ${SRC}/goals/GoalKillAllEnemies.cpp
-    ${SRC}/goals/GoalMineNGold.cpp
-    ${SRC}/goals/GoalProtectCreature.cpp
-    ${SRC}/goals/GoalProtectDungeonTemple.cpp
-
-    ${SRC}/modes/AbstractApplicationMode.cpp
-    ${SRC}/modes/Command.cpp
-    ${SRC}/modes/ConsoleCommands.cpp
-    ${SRC}/modes/ConsoleInterface.cpp
