=== source/tests/CMakeLists.txt ===
include(BoostTestTargets)

add_boost_test(00-Random
        SOURCES
        test_Random.cpp
        ${SRC}/utils/Random.h
        ${SRC}/utils/Random.cpp)

add_boost_test(00-ODPacket
        SOURCES
        test_ODPacket.cpp
        ${SRC}/network/ODPacket.h
        ${SRC}/network/ODPacket.cpp
        LIBRARIES
        ${SFML_LIBRARIES})

add_boost_test(00-ConsoleInterface
        SOURCES
        test_ConsoleInterface.cpp
        ${SRC}/modes/AbstractModeManager.h
        ${SRC}/modes/ConsoleInterface.h
        ${SRC}/modes/ConsoleInterface.cpp
        ${SRC}/modes/Command.h
        ${SRC}/modes/Command.cpp)

add_boost_test(00-Goal
        SOURCES
        test_Goal.cpp
        ${SRC}/goals/Goal.cpp
        ${SRC}/utils/LogManager.cpp
        ${SRC}/utils/LogSinkConsole.cpp
        LIBRARIES
        ${SFML_LIBRARIES}
        ${Boost_FILESYSTEM_LIBRARY_RELEASE}
        ${Boost_SYSTEM_LIBRARY_RELEASE})

add_boost_test(00-Pathfinding
        SOURCES
        test_Pathfinding.cpp)

add_boost_test(aa-LaunchGame
        SOURCES
        ${SRC}/tests/mocks/ODClientTest.cpp
        ${SRC}/game/SeatData.cpp
        ${SRC}/game/SkillType.cpp
        ${SRC}/network/ClientNotification.cpp
        ${SRC}/network/ODPacket.cpp
        ${SRC}/network/ODSocketClient.cpp
        ${SRC}/network/ODSocketServer.cpp
        ${SRC}/network/ServerMode.cpp
        ${SRC}/network/ServerNotification.cpp
        ${SRC}/utils/Helper.cpp
        ${SRC}/utils/LogManager.cpp
        ${SRC}/utils/LogSinkConsole.cpp
        test_LaunchGame.cpp
        LIBRARIES
        ${SFML_LIBRARIES}
        ${Boost_FILESYSTEM_LIBRARY_RELEASE}
        ${Boost_SYSTEM_LIBRARY_RELEASE}
        ${OGRE_LIBRARIES})

add_boost_test(aa-TestCreatures
        SOURCES
        ${SRC}/tests/mocks/ODClientTest.cpp
        ${SRC}/game/SeatData.cpp
        ${SRC}/game/SkillType.cpp
        ${SRC}/network/ClientNotification.cpp
        ${SRC}/network/ODPacket.cpp
        ${SRC}/network/ODSocketClient.cpp
        ${SRC}/network/ODSocketServer.cpp
        ${SRC}/network/ServerMode.cpp
        ${SRC}/network/ServerNotification.cpp
        ${SRC}/utils/Helper.cpp
        ${SRC}/utils/LogManager.cpp
        ${SRC}/utils/LogSinkConsole.cpp
        test_Creatures.cpp
        LIBRARIES
        ${SFML_LIBRARIES}
        ${Boost_FILESYSTEM_LIBRARY_RELEASE}
        ${Boost_SYSTEM_LIBRARY_RELEASE}
        ${OGRE_LIBRARIES})

add_boost_test(aa-TestRooms
        SOURCES
        ${SRC}/tests/mocks/ODClientTest.cpp
        ${SRC}/game/SeatData.cpp
        ${SRC}/game/SkillType.cpp
        ${SRC}/network/ClientNotification.cpp
        ${SRC}/network/ODPacket.cpp
        ${SRC}/network/ODSocketClient.cpp
        ${SRC}/network/ODSocketServer.cpp
        ${SRC}/network/ServerMode.cpp
        ${SRC}/network/ServerNotification.cpp
        ${SRC}/rooms/RoomType.cpp
        ${SRC}/utils/Helper.cpp
        ${SRC}/utils/LogManager.cpp
        ${SRC}/utils/LogSinkConsole.cpp
        test_Rooms.cpp
        LIBRARIES
        ${SFML_LIBRARIES}
        ${Boost_FILESYSTEM_LIBRARY_RELEASE}
        ${Boost_SYSTEM_LIBRARY_RELEASE}
        ${OGRE_LIBRARIES})

add_boost_test(ab-TestTraps
        SOURCES
        ${SRC}/tests/mocks/ODClientTest.cpp
        ${SRC}/game/SeatData.cpp
        ${SRC}/game/SkillType.cpp
        ${SRC}/network/ClientNotification.cpp
        ${SRC}/network/ODPacket.cpp
        ${SRC}/network/ODSocketClient.cpp
        ${SRC}/network/ODSocketServer.cpp
        ${SRC}/network/ServerMode.cpp
        ${SRC}/network/ServerNotification.cpp
        ${SRC}/rooms/RoomType.cpp
        ${SRC}/utils/Helper.cpp
        ${SRC}/utils/LogManager.cpp
        ${SRC}/utils/LogSinkConsole.cpp
        test_Traps.cpp
        LIBRARIES
        ${SFML_LIBRARIES}
        ${Boost_FILESYSTEM_LIBRARY_RELEASE}
        ${Boost_SYSTEM_LIBRARY_RELEASE}
        ${OGRE_LIBRARIES})
