=== debian/changelog ===
opendungeons (0.7.1-1mx150+1) mx; urgency=medium

  * Repackaged for MX 15.

 -- Mike Purtell <mandbx@sbcglobal.net>  Wed, 21 Sep 2016 11:22:46 -0700

opendungeons (0.7.1-1~getdeb1) xenial; urgency=medium

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Tue, 06 Sep 2016 18:14:22 +0200

opendungeons (0.7.0-1~getdeb1) xenial; urgency=medium

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Sat, 30 Jul 2016 22:44:43 +0200

opendungeons (0.6.0-1~getdeb3~wily) wily; urgency=medium

  * Rebuild for wily

 -- Christoph Korn <christoph.korn@getdeb.net>  Wed, 21 Oct 2015 22:14:28 +0200
