=== debian/watch ===
version=3
https://github.com/OpenDungeons/OpenDungeons/releases \
    (?:.*/)?archive/([\d\.]+)\.tar\.gz
